﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamGridObservableDictionary
{
    public partial class MainPage : UserControl
    {
        public ObservableDictionary<int, MyObject> xgdata { get; set; }
        public ObservableDictionary<int, MyObject> dgdata { get; set; }

        public MainPage()
        {
            InitializeComponent();
            xgdata = new ObservableDictionary<int, MyObject>(); dgdata = new ObservableDictionary<int, MyObject>(); Random r = new Random();

            for (int i = 0; i < 10; i++)
            {
                xgdata.Add(i, new MyObject(i) { Name = string.Format("Person {0:d6}", i), Age = (r.Next() % 80) + 1 });
                dgdata.Add(i, new MyObject(i) { Name = string.Format("Person {0:d6}", i), Age = (r.Next() % 80) + 1 });
            }

            xamgrid.DataContext = xgdata;
            datagrid.DataContext = dgdata;
        }

        private void Add_Click(object sender, RoutedEventArgs e)
        {
            int index = xgdata.Count; Random r = new Random();
            
            if (!xgdata.ContainsKey(index))
                xgdata.Add(index, new MyObject(index) { Name = string.Format("Person {0:d6}", index), Age = (r.Next() % 80) + 1 });
        }

        private void Remove_Click(object sender, RoutedEventArgs e)
        {
            int key = xgdata.LastOrDefault().Key;

            bool bSuccess = xgdata.Remove(key);
        }

        private void Update_Click(object sender, RoutedEventArgs e)
        {
            foreach (KeyValuePair<int, MyObject> kvp in xgdata)
                kvp.Value.Age++;
        }

        private void DGAdd_Click(object sender, RoutedEventArgs e)
        {
            int index = dgdata.Count; Random r = new Random();

            if (!dgdata.ContainsKey(index))
                dgdata.Add(index, new MyObject(index) { Name = string.Format("Person {0:d6}", index), Age = (r.Next() % 80) + 1 });
        }

        private void DGRemove_Click(object sender, RoutedEventArgs e)
        {
            int key = dgdata.LastOrDefault().Key;

            bool bSuccess = dgdata.Remove(key);
        }

        private void DGUpdate_Click(object sender, RoutedEventArgs e)
        {
            foreach (KeyValuePair<int, MyObject> kvp in dgdata)
                kvp.Value.Age++;
        }
    }

    public class MyObject : INotifyPropertyChanged
    {
        public MyObject(int objid)
        {
            _ObjectID = objid;
        }

        private int _ObjectID;
        public int ObjectID
        {
            get
            {
                return _ObjectID;
            }
        }

        private int _Age;
        public int Age
        {
            get
            {
                return _Age;
            }

            set
            {
                _Age = value;

                this.OnPropertyChanged("Age");
            }
        }

        private string _Name;
        public string Name
        {
            get
            {
                return _Name;
            }

            set
            {
                _Name = value;

                this.OnPropertyChanged("Name");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propname)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propname));
            }
        }
    }
}
